//----------------------------------------------------------------------//
// R}h`[													//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <memory>
#include <tchar.h>
#include <algorithm>
#include <shellapi.h>
#include <mmsystem.h>
#include "UserFunc.h"
#include "UIniFile.h"
#include "Unit1.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCmdLncForm *CmdLncForm = NULL;

//---------------------------------------------------------------------------
__fastcall TCmdLncForm::TCmdLncForm(TComponent* Owner)
    : TForm(Owner)
{
	BorderStyle = HotQMainForm->CmdNoTbar? bsNone : bsToolWindow;
}
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::FormShow(TObject *Sender)
{
	UnicodeString sct = "CmdLauncher";
	Left = IniFile->ReadInteger(sct,"PosX", 0);
	Top  = IniFile->ReadInteger(sct,"PosY", 0);

	CnfSound   = IniFile->ReadString(sct, "CnfSound");
	NgSound    = IniFile->ReadString(sct, "NgSound");
	FgColorK   = IniFile->ReadColor( sct, "FgColorK", clWindowText);
	BgColorK   = IniFile->ReadColor( sct, "BgColorK", clWindow);
	FgColorC   = IniFile->ReadColor( sct, "FgColorC", clWindowText);
	BgColorC   = IniFile->ReadColor( sct, "BgColorC", clWindow);
	SkipInput  = IniFile->ReadBool(  sct, "SkipInput");
	DropDown   = IniFile->ReadBool(  sct, "Dropdown", true);
	CnfExecute = IniFile->ReadBool(  sct, "CnfExecute");
	ExeDelay   = IniFile->ReadInteger(sct, "ExeDelay", 250);

	KwdComboBox->Font->Color   = FgColorK;
	KwdComboBox->Color		   = BgColorK;
	KwdComboBox->DropDownCount = IniFile->ReadInteger(sct, "ListSize", 10);
	if (HotQMainForm->CmdKwFont) KwdComboBox->Font->Assign(HotQMainForm->CmdKwFont);
	int mg = (BorderStyle == bsNone) ? 6 : 2;
	int lw = IniFile->ReadInteger(sct, "ListWidth", 0);
	int bw = std::max(KwdComboBox->Height, 22);
	int hd = (BorderStyle == bsNone) ? std::min(12, bw/3) : 0;
	KwdComboBox->Width = (lw==0) ? KwdComboBox->Height*10 : lw;
	KwdComboBox->Left  = hd + mg/2;
	KwdComboBox->Top   = mg/2;
	ExeBtn->SetBounds(ClientWidth-bw-mg/2, mg/2, bw, bw);
	ClientWidth  = hd + KwdComboBox->Width + ExeBtn->Width + mg;
	ClientHeight = bw + mg;

	IconSize = (ExeBtn->Width>36) ? 32 : 16;

	PreWord = EmptyStr;
	CurHKp	= NULL;
	KwdComboBox->Enabled = true;
	UpdateKwdComboBox();
}
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::FormHide(TObject *Sender)
{
	KwdComboBox->DroppedDown = false;
	UnicodeString sct = "CmdLauncher";
	IniFile->WriteInteger(sct,"PosX",	Left);
	IniFile->WriteInteger(sct,"PosY",	Top);
	IniFile->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::FormPaint(TObject *Sender)
{
	if (BorderStyle == bsNone) {
		::DrawEdge(Canvas->Handle, &ClientRect, EDGE_RAISED, BF_RECT);
		TRect rc = Rect(4,4,7,ClientHeight-4);
		::DrawEdge(Canvas->Handle, &rc, BDR_RAISEDINNER, BF_RECT);
	}
}
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if (BorderStyle==bsNone) {
		::ReleaseCapture();
		::SendMessage(Handle, WM_SYSCOMMAND, SC_MOVE|2, 0);
	}
}

//---------------------------------------------------------------------------
//s
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::ExeBtnClick(TObject *Sender)
{
	KwdComboBox->DroppedDown = false;
	KwdComboBox->Enabled	 = false;
	ExeBtn->Enabled 		 = false;
	if (CurHKp) {
		Hide();
		::SendMessage(HotQMainForm->Handle, WM_HOTKEY, CurHKp->id, 0);
	}
	if (Visible) Hide();
}

//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::KwdComboBoxChange(TObject *Sender)
{
	if (!KwdComboBox->Enabled) return;

	if (!KwdComboBox->DroppedDown) {
		if (KwdComboBox->Text.IsEmpty()) {
			KwdComboBox->Clear();
			for (int i=CmdKwTopIndex; i<HKeyList->Count; i++) {
				HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
				KwdComboBox->Items->Add(kp->KeyWord);
			}
			PreWord = EmptyStr;
		}
		else
			PreWord = KwdComboBox->Text.SubString(1, KwdComboBox->SelStart);
	}
	SetIcon();
}

//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::KwdComboBoxKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	TComboBox *cbp = dynamic_cast<TComboBox*>(Sender);
	switch (Key) {
	case VK_ESCAPE:
		if (cbp->DroppedDown) {
			cbp->DroppedDown = false;
			cbp->SelStart	 = (cbp->Items->Count>0) ? PreWord.Length() : 0;
			cbp->SelLength	 = 100;
		}
		else
			Close();
		break;
	case VK_UP: case VK_DOWN:
		cbp->DroppedDown = true;
		break;
	case VK_RETURN:
		if (cbp->DroppedDown) ExeBtnClick(Sender);
		break;
	case VK_BACK:
		if (!PreWord.IsEmpty()) {
			if (cbp->Items->Count==1 || SkipInput)
				PreWord = EmptyStr;
			else
				PreWord.Delete(PreWord.Length(), 1);
			cbp->DroppedDown = false;
			UpdateKwdComboBox();
			Key = 0;
		}
		break;
	case VK_DELETE:
		if (!PreWord.IsEmpty()) {
			if (cbp->SelText.IsEmpty()) PreWord = EmptyStr;
			cbp->DroppedDown = false;
			UpdateKwdComboBox();
		}
		break;
	case VK_LEFT: case VK_RIGHT:
		break;
	default:
		if (!Shift.Contains(ssAlt) && !Shift.Contains(ssCtrl))
			cbp->DroppedDown = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::KwdComboBoxKeyPress(TObject *Sender, char &Key)
{
	if (HIBYTE(GetAsyncKeyState(VK_CONTROL)) || HIBYTE(GetAsyncKeyState(VK_MENU))) {
		Key = 0; return;
	}

	if (isprint(Key)) {
		KwdComboBox->DroppedDown = false;
		TStrings *ip = KwdComboBox->Items;
		UnicodeString k = Key;
		bool ok = false;
		int p = PreWord.Length()+1;
		for (int i=0; i<ip->Count; i++) {
			if (SameText(k, ip->Strings[i].SubString(p,1))) {
				ok = true;  break;
			}
		}
		if (ok)
			PreWord += Key;
		else {
			if (get_file_name_r(NgSound)) ::sndPlaySound(NgSound.c_str(), SND_ASYNC);
		}
		UpdateKwdComboBox();
		Key = 0;
	}
	else {
		switch (Key) {
		case VK_RETURN: case VK_ESCAPE:
			Key = 0; break;
		}
	}

	KwdComboBox->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::KwdComboBoxKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (HIBYTE(GetAsyncKeyState(VK_CONTROL)) || HIBYTE(GetAsyncKeyState(VK_MENU))) {
		Key = 0; return;
	}

	//BCB52007ComboBox̋ςĂ܂Ƃւ̑Ώ
	if (KwdComboBox->ItemIndex!=-1) {
		KwdComboBox->Text	   = KwdComboBox->Items->Strings[KwdComboBox->ItemIndex];
		KwdComboBox->SelStart  = PreWord.Length();
		KwdComboBox->SelLength = 100;
		KwdComboBox->Repaint();
	}
}

//---------------------------------------------------------------------------
//⃊Xg̍XV
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::UpdateKwdComboBox()
{
	TStrings *ip = KwdComboBox->Items;
	int pln = PreWord.Length();
	KwdComboBox->Clear();
	for (int i=CmdKwTopIndex; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		if (!PreWord.IsEmpty()) {
			if (!SameText(kp->KeyWord.SubString(1, pln), PreWord)) continue;
		}
		ip->Add(kp->KeyWord);
	}

	if (!PreWord.IsEmpty()) {
		if (ip->Count>0) {
			if (SkipInput) {
				//̓XLbv
				if (ip->Count==1)
					PreWord = ip->Strings[0];
				else if (ip->Count>1) {
					int maxw = PreWord.Length();
					for (;;) {
						if (maxw==ip->Strings[0].Length()) break;
						UnicodeString mstr = ip->Strings[0].SubString(1, maxw+1);
						bool ok = true;
						for (int i=1; i<ip->Count; i++) {
							if (SameText(mstr, ip->Strings[i].SubString(1, maxw+1))) continue;
							ok = false;  break;
						}
						if (!ok) break;
						PreWord = mstr;
						maxw++;
					}
				}
			}
			KwdComboBox->ItemIndex = 0;

		}
		else
			KwdComboBox->Text = PreWord;
	}

	if (DropDown && ip->Count>1 && !KwdComboBox->Text.IsEmpty())
		KwdComboBox->DroppedDown = true;

	SetIcon();
}

//---------------------------------------------------------------------------
//s{^ɃACRݒ
//---------------------------------------------------------------------------
void __fastcall TCmdLncForm::SetIcon()
{
	UnicodeString kwd = KwdComboBox->Text;
	bool found = false;
	CurHKp = NULL;
	std::unique_ptr<Graphics::TBitmap> img(new Graphics::TBitmap());
	if (!kwd.IsEmpty()) {
		for (int i=CmdKwTopIndex; i<HKeyList->Count; i++) {
			HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
			if (!SameText(kwd, kp->KeyWord)) continue;
			CurHKp = kp;
			found  = true;
			UnicodeString ifile = !kp->ico_file.IsEmpty()?  kp->ico_file : kp->exe_file[0];
			if (ifile.IsEmpty()) break;
			if (ExtractFileDrive(ifile).IsEmpty())
				ifile = ExtractFilePath(Application->ExeName) + ifile;

			SHFILEINFO sif;
			UINT flag = SHGFI_ICON;
			flag |= ((IconSize==16)? SHGFI_SMALLICON : SHGFI_LARGEICON);
			if (::SHGetFileInfo(ifile.c_str(), 0, &sif, sizeof(SHFILEINFO), flag) != 0) {
				img->SetSize(IconSize, IconSize+1);	//[̓ߐFh~
				img->Canvas->Brush->Color = Color;
				img->Canvas->FillRect(Rect(0,0,IconSize,IconSize+1));
				::DrawIconEx(img->Canvas->Handle,
					0,0, sif.hIcon, IconSize, IconSize, 0, NULL, DI_NORMAL);
				::DestroyIcon(sif.hIcon);
			}
			break;
		}
	}

	if (img->Empty) {
		img->SetSize(IconSize, IconSize+1);	//[̓ߐFh~
		img->Canvas->Brush->Color = Color;
		img->Canvas->FillRect(Rect(0,0,IconSize,IconSize+1));
		::DrawIconEx(img->Canvas->Handle, 0,0,
			((IconSize==16)? HotQMainForm->hSmallIcon : Application->Icon->Handle),
			IconSize, IconSize, 0, NULL, DI_NORMAL);
	}

	if (KwdComboBox->Items->Count==1) {
		KwdComboBox->Font->Color = FgColorC;
		KwdComboBox->Color		 = BgColorC;
		if (get_file_name_r(CnfSound)) ::sndPlaySound(CnfSound.c_str(), SND_ASYNC);
	}
	else {
		KwdComboBox->Font->Color = FgColorK;
		KwdComboBox->Color		 = BgColorK;
	}

	KwdComboBox->SelStart  = (KwdComboBox->Items->Count>0)? PreWord.Length() : 0;
	KwdComboBox->SelLength = 100;
	KwdComboBox->Repaint();

	ExeBtn->Enabled = found;
	ExeBtn->Glyph->Assign(img.get());

	if (CnfExecute && KwdComboBox->Items->Count==1) {
		Sleep(ExeDelay);
		ExeBtnClick(NULL);
	}
}
//---------------------------------------------------------------------------

