//----------------------------------------------------------------------//
//	WIC ֘A															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <utilcls.h>
#include "usr_wic.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//ΉĂt@CH
//---------------------------------------------------------------------------
bool WIC_is_available(UnicodeString fnam)
{
	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>	factory;
		TComInterface<IWICBitmapDecoder>	decoder;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
			GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
				throw Exception(EmptyStr);

		UINT f_cnt;
		if (FAILED(decoder->GetFrameCount(&f_cnt))) throw Exception(EmptyStr);
		if (f_cnt==0) throw Exception(EmptyStr);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//ew`ŃfR[hărbg}bv擾
//---------------------------------------------------------------------------
bool WIC_get_from_memory(TMemoryStream *ms, Graphics::TBitmap *o_bmp, REFGUID fmt)
{
	try {
		::CoInitialize(NULL);
		TComInterface<IWICImagingFactory>		factory;
		TComInterface<IWICStream>				stream;
		TComInterface<IWICBitmapDecoder>		decoder;
		TComInterface<IWICFormatConverter>		converter;
		TComInterface<IWICBitmapFrameDecode>	frame;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateStream(&stream)))				throw Exception(EmptyStr);
		if (FAILED(stream->InitializeFromMemory(reinterpret_cast<BYTE*>(ms->Memory), ms->Size)))
			throw Exception(EmptyStr);

		if (FAILED(factory->CreateDecoderFromStream(stream, NULL, WICDecodeMetadataCacheOnLoad, &decoder)))
			throw Exception(EmptyStr);
		if (FAILED(decoder->GetFrame( 0, &frame)))				throw Exception(EmptyStr);
		if (FAILED(factory->CreateFormatConverter(&converter))) throw Exception(EmptyStr);

		if (FAILED(converter->Initialize(frame,
			GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
				throw Exception(EmptyStr);

		//TCY擾
		UINT i_wd, i_hi;
		if (FAILED(converter->GetSize(&i_wd, &i_hi))) throw Exception(EmptyStr);
		//C[WɃRs[
		UINT stride = i_wd * 3;
		std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
		if (FAILED(converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) throw Exception(EmptyStr);
		//rbg}bvɃRs[
		o_bmp->PixelFormat = pf24bit;
		o_bmp->SetSize(i_wd, i_hi);
		BYTE *bp = ibuf.get();
		for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//t@Cw肵ނ̃rbg}bv擾
// img_type : default = WICIMG_PREVIEW;
//---------------------------------------------------------------------------
bool WIC_load_image(UnicodeString fnam, Graphics::TBitmap *o_bmp, int img_type)
{
	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>		factory;
		TComInterface<IWICBitmapDecoder>		decoder;
		TComInterface<IWICFormatConverter>		converter;
		TComInterface<IWICBitmapFrameDecode>	frame;
		TComInterface<IWICBitmapSource> 		preview;
		TComInterface<IWICBitmapSource>			thumbnail;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
			GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateFormatConverter(&converter))) throw Exception(EmptyStr);

		HRESULT res = S_FALSE;
		if (img_type==WICIMG_THUMBNAIL) {
			//TlC擾
			res = decoder->GetThumbnail(&thumbnail);
			if (res==S_OK && FAILED(converter->Initialize(thumbnail,
				GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
					throw Exception(EmptyStr);
		}
		if (res!=S_OK || img_type==WICIMG_PREVIEW) {
			//vr[擾
			res = decoder->GetPreview(&preview);
			if ((res==S_OK) && FAILED(converter->Initialize(preview,
				GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
					throw Exception(EmptyStr);
		}
		if (res!=S_OK) {
			//t[擾
			res = decoder->GetFrame(0, &frame);
			if (res==S_OK && FAILED(converter->Initialize(frame,
				GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
					throw Exception(EmptyStr);
		}
		if (FAILED(res)) throw Exception(EmptyStr);

		//TCY擾
		UINT i_wd, i_hi;
		if (FAILED(converter->GetSize(&i_wd, &i_hi))) throw Exception(EmptyStr);
		//C[WɃRs[
		UINT stride = i_wd * 3;
		std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
		if (FAILED(converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) throw Exception(EmptyStr);
		//rbg}bvɃRs[
		o_bmp->PixelFormat = pf24bit;
		o_bmp->SetSize(i_wd, i_hi);
		BYTE *bp = ibuf.get();
		for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//rbg}bvw`Ńt@Cɕۑ
//   img_q : jpeg 掿				(0`100 default = 100)
//    ycrcb: jpeg TuTvO	(0`3	default = 0)
// cmp_mode: tiff k				(0`7   default = 0)
//---------------------------------------------------------------------------
bool WIC_save_image(UnicodeString fnam, Graphics::TBitmap *i_bmp,
	int img_q, int ycrcb, int cmp_mode)
{
	UnicodeString fext = ExtractFileExt(fnam).UpperCase();
	GUID fmt;
	if		(UnicodeString(".BMP.").Pos(fext)>0)			fmt = GUID_ContainerFormatBmp;
	else if (UnicodeString(".JPG.JPEG.JPE.").Pos(fext)>0)	fmt = GUID_ContainerFormatJpeg;
	else if (UnicodeString(".PNG.").Pos(fext)>0)			fmt = GUID_ContainerFormatPng;
	else if (UnicodeString(".GIF.").Pos(fext)>0)			fmt = GUID_ContainerFormatGif;
	else if (UnicodeString(".TIF.").Pos(fext)>0)			fmt = GUID_ContainerFormatTiff;
	else if (UnicodeString(".HDP.WDP.").Pos(fext)>0)		fmt = GUID_ContainerFormatWmp;
	else return false;

	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>		factory;
		TComInterface<IWICStream>				stream;
		TComInterface<IWICBitmapEncoder>		encoder;
		TComInterface<IWICBitmap>				bitmap;
		TComInterface<IWICBitmapFrameEncode>	frame;
		TComInterface<IPropertyBag2>			properties;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateStream(&stream)))							throw Exception(EmptyStr);
		if (FAILED(stream->InitializeFromFilename(fnam.c_str(), GENERIC_WRITE))) throw Exception(EmptyStr);
		if (FAILED(factory->CreateEncoder(fmt, NULL, &encoder)))			throw Exception(EmptyStr);
        if (FAILED(encoder->Initialize(stream, WICBitmapEncoderNoCache)))	throw Exception(EmptyStr);
		if (FAILED(encoder->CreateNewFrame(&frame, &properties)))			throw Exception(EmptyStr);

		//IvVݒ
		PROPBAG2 option = { 0 };
		VARIANT varValue;
		//JpegAHDP: i
		if (fmt==GUID_ContainerFormatJpeg || fmt==GUID_ContainerFormatWmp) {
			option.pstrName = L"ImageQuality";
			VariantInit(&varValue);
			varValue.vt 	= VT_R4;
			varValue.fltVal = (float)((img_q<100)? img_q/100.0 : 1.0);
			if (FAILED(properties->Write(1, &option, &varValue))) throw Exception(EmptyStr);
		}
		//JpegP: YCrCb TuTvO
		if (fmt==GUID_ContainerFormatJpeg && ycrcb>=0 && ycrcb<=3) {
			option.pstrName = L"JpegYCrCbSubsampling";
			VariantInit(&varValue);
			varValue.vt 	= VT_UI1;
			varValue.bVal	= ycrcb;
			if (FAILED(properties->Write(1, &option, &varValue))) throw Exception(EmptyStr);
		}
		//Tiff: k@
		if (fmt==GUID_ContainerFormatTiff && cmp_mode>=0 && cmp_mode<=7) {
			option.pstrName = L"TiffCompressionMethod";
			VariantInit(&varValue);
			varValue.vt 	= VT_UI1;
			varValue.bVal	= cmp_mode;
			if (FAILED(properties->Write(1, &option, &varValue))) throw Exception(EmptyStr);
		}

		if (FAILED(frame->Initialize(properties)))	throw Exception(EmptyStr);

		//\[Xrbg}bv쐬
		if (FAILED(factory->CreateBitmapFromHBITMAP(
			i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
				throw Exception(EmptyStr);

		if (FAILED(frame->WriteSource(bitmap, 0)))	throw Exception(EmptyStr);
		if (FAILED(frame->Commit()))				throw Exception(EmptyStr);
		if (FAILED(encoder->Commit()))				throw Exception(EmptyStr);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//摜̏kEg
//  i_bmp : ̓rbg}bv
//  o_bmp : o̓rbg}bv
//
//	ratio : {		0.0 : 
//   s_wd : TCY	  0 : 
//   s_hi : cTCY
//			{TCŶꂩw
//   s_opt: ASY
//---------------------------------------------------------------------------
bool WIC_resize_image(Graphics::TBitmap *i_bmp, Graphics::TBitmap *o_bmp,
	double ratio, unsigned int s_wd, unsigned int s_hi, int s_opt)
{
	if (ratio<=0.0 && (s_wd==0 || s_hi==0)) return false;

	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>	factory;
		TComInterface<IWICBitmap>			bitmap;
		TComInterface<IWICBitmapScaler> 	scaler;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		//\[Xrbg}bv쐬
		i_bmp->PixelFormat = pf24bit;
		if (FAILED(factory->CreateBitmapFromHBITMAP(
			i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateBitmapScaler(&scaler))) throw Exception(EmptyStr);

		//TCY
		UINT i_wd, i_hi;
		if (ratio>0) {
			i_wd = i_bmp->Width  * ratio;
			i_hi = i_bmp->Height * ratio;
		}
		else {
			i_wd = s_wd;
			i_hi = s_hi;
		}
		WICBitmapInterpolationMode opt;
		switch (s_opt) {
		case 1:  opt = WICBitmapInterpolationModeLinear; break;		//oCjA
		case 2:  opt = WICBitmapInterpolationModeCubic;	 break;		//oCL[rbN
		case 3:  opt = WICBitmapInterpolationModeFant;	 break;		//t@gTvO
		default: opt = WICBitmapInterpolationModeNearestNeighbor;	//ŋߖT@
		}
		if (FAILED(scaler->Initialize(bitmap, i_wd, i_hi, opt)))
			throw Exception(EmptyStr);

		//C[WɃRs[
		UINT stride = i_wd * 3;
		std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
		if (FAILED(scaler->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) throw Exception(EmptyStr);
		//rbg}bvɃRs[
		o_bmp->PixelFormat = pf24bit;
		o_bmp->SetSize(i_wd, i_hi);
		BYTE *bp = ibuf.get();
		for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//摜̉]E]
// rot_opt : 1:90/ 2:180/ 3:270(90)/ 4:E]/ 5:㉺]
//---------------------------------------------------------------------------
bool WIC_rotate_image(Graphics::TBitmap *i_bmp, int rot_opt)
{
	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>		factory;
		TComInterface<IWICBitmap>				bitmap;
		TComInterface<IWICBitmapFlipRotator> 	rotator;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		//\[Xrbg}bv쐬
		i_bmp->PixelFormat = pf24bit;
		if (FAILED(factory->CreateBitmapFromHBITMAP(i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
			throw Exception(EmptyStr);

		//]
		if (FAILED(factory->CreateBitmapFlipRotator(&rotator))) throw Exception(EmptyStr);
		WICBitmapTransformOptions opt;
		switch (rot_opt) {
		case  1: opt = WICBitmapTransformRotate90;	break;
		case  2: opt = WICBitmapTransformRotate180;	break;
		case  3: opt = WICBitmapTransformRotate270;	break;
		case  4: opt = WICBitmapTransformFlipHorizontal;	break;
		case  5: opt = WICBitmapTransformFlipVertical;		break;
		default: opt = WICBitmapTransformRotate0;	break;
 		}
		if (FAILED(rotator->Initialize(bitmap, opt))) throw Exception(EmptyStr);

		//TCY擾
		UINT i_wd, i_hi;
		if (FAILED(rotator->GetSize(&i_wd, &i_hi))) throw Exception(EmptyStr);
		//C[WɃRs[
		UINT stride = i_wd * 3;
		std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
		if (FAILED(rotator->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) throw Exception(EmptyStr);
		//rbg}bvɃRs[
		i_bmp->PixelFormat = pf24bit;
		i_bmp->SetSize(i_wd, i_hi);
		BYTE *bp = ibuf.get();
		for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(i_bmp->ScanLine[i], bp, stride);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//O[XP[
//---------------------------------------------------------------------------
bool WIC_grayscale_image(Graphics::TBitmap *i_bmp)
{
	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>		factory;
		TComInterface<IWICBitmap>				bitmap;
		TComInterface<IWICFormatConverter>		g_converter;
		TComInterface<IWICFormatConverter>		o_converter;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		//\[Xrbg}bv쐬
		if (FAILED(factory->CreateBitmapFromHBITMAP(i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
			throw Exception(EmptyStr);
		//O[XP[ɕϊ
		if (FAILED(factory->CreateFormatConverter(&g_converter))) throw Exception(EmptyStr);
		if (FAILED(g_converter->Initialize(bitmap,
			GUID_WICPixelFormat8bppGray, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
				throw Exception(EmptyStr);
		//24bit BGR ɕϊ
		if (FAILED(factory->CreateFormatConverter(&o_converter))) throw Exception(EmptyStr);
		if (FAILED(o_converter->Initialize(g_converter,
			GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
				throw Exception(EmptyStr);

		//TCY擾
		UINT i_wd, i_hi;
		if (FAILED(o_converter->GetSize(&i_wd, &i_hi))) throw Exception(EmptyStr);
		//C[WɃRs[
		UINT stride = i_wd * 3;
		std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
		if (FAILED(o_converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) throw Exception(EmptyStr);
		//rbg}bvɃRs[
		i_bmp->PixelFormat = pf24bit;
		i_bmp->SetSize(i_wd, i_hi);
		BYTE *bp = ibuf.get();
		for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(i_bmp->ScanLine[i], bp, stride);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}

//---------------------------------------------------------------------------
//摜̃TCY擾
// img_type : default = WICIMG_PREVIEW;
//---------------------------------------------------------------------------
bool WIC_get_img_size(UnicodeString fnam, unsigned int *wd, unsigned int *hi)
{
	try {
		::CoInitialize(NULL);

		TComInterface<IWICImagingFactory>		factory;
		TComInterface<IWICBitmapDecoder>		decoder;
		TComInterface<IWICBitmapFrameDecode>	frame;

		if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory,NULL,
			CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
				throw Exception(EmptyStr);

		if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
			GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
				throw Exception(EmptyStr);

		if (FAILED(decoder->GetFrame(0, &frame)))	throw Exception(EmptyStr);
		if (FAILED(frame->GetSize(wd, hi)))			throw Exception(EmptyStr);

		::CoUninitialize();
		return true;
	}
	catch (...) {
		::CoUninitialize();
		return false;
	}
}
//---------------------------------------------------------------------------
